from src.config import logging


class SolarPanel:
    """Class for the solar panel inside a building.

    Args:
        solar_efficiency: Solar efficiency of the solar panel per m^2.
        panel_area: Area of the solar panel in m^2.

    Attributes:
        solar_efficiency: Solar efficiency of the solar panel per m^2.
        panel_area: Area of the solar panel in m^2.
        generated_energy: Total energy generated by the solar panel.
        generation_history: History of the energy generated at each hour.
    """

    def __init__(self, solar_efficiency=None, panel_area=None):
        self.solar_efficiency = solar_efficiency
        self.panel_area = panel_area

        self.generated_energy = 0
        self.generation_history = []

    def set_energy_input(self, energy_incident: float) -> None:
        """Update the energy generated by the solar panel.

        Args:
            energy_incident: Incident solar energy coming from the sun.
        """
        cur_energy = self.solar_efficiency * self.panel_area * energy_incident

        self.generated_energy += cur_energy
        self.generation_history.append(cur_energy)

    def get_energy_consumption(self) -> float:
        """
        Returns:
            The energy consumed by the solarpanel (as an algebric value). It is
        always negative as the solar panel can only produce energy.
        """
        return (
            0
            if len(self.generation_history) == 0
            else -self.generation_history[-1]
        )

    def get_generated_energy(self) -> float:
        """
        Returns:
             The total generated energy by the solar panel.
        """
        return self.generated_energy

    def describe(self) -> None:
        """Logging function for the solar panel."""
        logging.info(
            "Solar panel:\n"
            f"Power generated={self.get_generated_energy()} kWh\n"
        )

    def reset(self) -> None:
        """Reset function for the solar panel."""
        self.generated_energy = 0
        self.generation_history = []
